image: adoptopenjdk/openjdk11:alpine-slim

variables:
  DOCKER_DRIVER: overlay2

before_script:
  - export GRADLE_USER_HOME=`pwd`/.gradle

cache:
  paths:
    - .gradle

stages:
  - build
  - deploy

build:
  stage: build
  script:
    - ./gradlew --no-daemon -i --parallel sonarqube spotbugsMain -Dsonar.branch.name=${CI_COMMIT_REF_NAME}
  artifacts:
    paths:
      - build/libs
    reports:
      junit: [ build/test-results/test/*.xml, build/test-results/integrationTest/*.xml ]
  except:
    - master

pages:
  stage: deploy
  script:
    - ./gradlew --no-daemon -i --parallel checkstyleMain spotbugsMain sonarqube sourceXref publish -Dsonar.branch.name=${CI_COMMIT_REF_NAME}
    - mkdir public
    - mv build/docs/javadoc public/apidocs
    - mv build/docs/source-xref public/source
    - mv build/reports/jacoco/jacocoFullReport/html public/coverage
    - mv build/reports/tests/test public/unit-tests
    - mv build/reports/integration-tests public/integration-tests
    - mkdir -p public/checkstyle
    - mv build/reports/checkstyle/main.html public/checkstyle/index.html
  artifacts:
    paths:
      - build/libs
      - build/publications
      - public
    reports:
      junit: [ build/test-results/test/*.xml, build/test-results/integrationTest/*.xml ]
  only:
    - master
